/* (C) 2022 YiRing, Inc. */
package com.yiring.app.push.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.yiring.app.push.domain.PushMessage;
import com.yiring.app.push.domain.PushMessageRepository;
import com.yiring.app.push.service.PushService;
import java.time.LocalDateTime;
import javax.annotation.Resource;
import javax.transaction.Transactional;
import lombok.extern.slf4j.Slf4j;
import org.springframework.amqp.core.AmqpTemplate;
import org.springframework.stereotype.Service;

/**
 * 推送服务实现
 *
 * @author Jim
 * @version 0.1
 * 2022/4/14 16:08
 */

@Slf4j
@Service
@Transactional(rollbackOn = Exception.class)
public class PushServiceImpl implements PushService {

    @Resource
    PushMessageRepository repository;

    @Resource
    AmqpTemplate amqpTemplate;

    @Override
    public void push(PushMessage.Type type, JSONObject raw) {
        PushMessage message = new PushMessage();
        message.setType(type);
        message.setExtra(raw);
        message.setCreateTime(LocalDateTime.now());
        repository.saveAndFlush(message);
        amqpTemplate.convertAndSend(type.queue(), message.getId());
    }
}
